pushed = B;

set(buttons,'Enable','off');
set(ui,'Enable','off');

armid = zeros(1,length(ui));
for uiid=1:length(ui)
	armid(uiid) = str2num(get(ui(uiid),'tag'));
end

stepTh = 0.2;

%if strcmp(pushed,'リセット')
if pushed == 1
	targetTh = zeros(1,length(ui));
	isdone = zeros(1,length(ui));
	[arm,plot1,ui,isdone] = update(targetTh, isdone, stepTh, ui, arm, armid, ind, plot1, sub22);
	
	
%elseif strcmp(pushed, '拳を握る')
elseif pushed == 2
	targetTh = zeros(1,length(ui));
	isdone = ones(1,length(ui));
	for uiid=[7:20,27:40]
		targetTh(uiid) = arm(armid(uiid)).limit(2);
		isdone(uiid) = 0;
	end
	[arm,plot1,ui,isdone] = update(targetTh, isdone, stepTh, ui, arm, armid, ind, plot1, sub22);
	
	
%elseif strcmp(pushed, 'ピース')
elseif pushed == 3
	targetTh = zeros(1,length(ui));
	targetTh(1) = 0.34;
	targetTh(4) = 2.0;
	targetTh(5) = pi/2;
	targetTh(6) = -0.75;
	for uiid = [7,8,15:20]
		targetTh(uiid) = arm(armid(uiid)).limit(2);
	end	
	isdone = zeros(1,length(ui));
	[arm,plot1,ui,isdone] = update(targetTh, isdone, stepTh, ui, arm, armid, ind, plot1, sub22);
	
	
%elseif strcmp(pushed, 'バイバイ')
elseif pushed == 4
	targetTh = zeros(1,length(ui));
	isdone = zeros(1,length(ui));
	for i = 1:2
		targetTh(1) = 2.46;
		targetTh(2) = 0.47;
		targetTh(3) = pi/2;
		targetTh(4) = 0.69;
		targetTh(5) = 0.77;
		isdone(1:5) = 0;
		[arm,plot1,ui,isdone] = update(targetTh, isdone, stepTh, ui, arm, armid, ind, plot1, sub22);

		targetTh(2) = -0.84;
		targetTh(3) = 0.28;
		targetTh(4) = 0;
		targetTh(5) = 0.72;
		targetTh(6) = -0.35;
		isdone(2:6) = 0;
		[arm,plot1,ui,isdone] = update(targetTh, isdone, stepTh, ui, arm, armid, ind, plot1, sub22);
	end
	
	
%elseif strcmp(pushed,'じゃんけんぽん')
elseif pushed == 5
	% 初期状態
	targetTh = zeros(1,length(ui));
	targetTh(1) = 1.07;
	targetTh(2) = -0.17;
	targetTh(4) = 1.90;
	targetTh(5) = 0.8;
	targetTh(6) = -0.7;
	for uiid=7:20
		targetTh(uiid) = arm(armid(uiid)).limit(2) / 2;
	end
	isdone = zeros(1,length(ui));
	[arm,plot1,ui,isdone] = update(targetTh, isdone, stepTh, ui, arm, armid, ind, plot1, sub22);
	
	% じゃん
	targetTh(1) = 0.08;
	targetTh(4) = 1.73;
	isdone([1,4]) = 0;
	[arm,plot1,ui,isdone] = update(targetTh, isdone, stepTh, ui, arm, armid, ind, plot1, sub22);
	
	% けん
	targetTh(1) = 1.07;
	targetTh(4) = 1.90;
	isdone([1,4]) = 0;
	[arm,plot1,ui,isdone] = update(targetTh, isdone, stepTh, ui, arm, armid, ind, plot1, sub22);
	
	% ぽん
	targetTh(1) = 0.39;
	targetTh(3) = -0.08;
	targetTh(4) = 1.38;
	targetTh(5) = 1.26;
	targetTh(6) = -1.17;
	p = rand;
	if p < 1/3  % グー
		isdone([1,3:6]) = 0;
	elseif p < 2/3  % チョキ
		targetTh(9:14) = 0;
		isdone([1,3:6,9:14]) = 0;
	else  % パー
		targetTh(7:20) = 0;
		isdone([1,3:6,7:20]) = 0;
	end
	[arm,plot1,ui,isdone] = update(targetTh, isdone, stepTh, ui, arm, armid, ind, plot1, sub22);
	
	
%elseif strcmp(pushed,'ありがとう')
elseif pushed == 6
	targetTh = zeros(1,length(ui));
	targetTh(1) = 0.50;
	targetTh(2) = -0.13;
	targetTh(3) = 0.59;
	targetTh(4) = 2.43;
	targetTh(21) = 0.92;
	targetTh(22) = 0.04;
	targetTh(23) = 1.57;
	targetTh(24) = 1.27;
	targetTh(25) = 0.59;
	isdone = zeros(1,length(ui));
	[arm,plot1,ui,isdone] = update(targetTh, isdone, stepTh, ui, arm, armid, ind, plot1, sub22);
	
	targetTh(1) = -0.34;
	targetTh(4) = 2.08;
	isdone([1,4]) = 0;
	[arm,plot1,ui,isdone] = update(targetTh, isdone, stepTh, ui, arm, armid, ind, plot1, sub22);
	
	targetTh(1) = 0.50;
	targetTh(4) = 2.43;
	isdone([1,4]) = 0;
	[arm,plot1,ui,isdone] = update(targetTh, isdone, stepTh, ui, arm, armid, ind, plot1, sub22);
	
end
set(buttons,'Enable','on');
set(ui,'Enable','on');

function [arm,plot1,ui,isdone] = update(targetTh, isdone, stepTh, ui, arm, armid, ind, plot1, sub22)
	while any(isdone == 0)
		for uiid=find(isdone == 0)
			if abs(arm(armid(uiid)).th - targetTh(uiid)) < stepTh
				arm(armid(uiid)).th = targetTh(uiid);
				isdone(uiid) = 1;
			elseif arm(armid(uiid)).th > targetTh(uiid)
				arm(armid(uiid)).th = arm(armid(uiid)).th - stepTh;
			else
				arm(armid(uiid)).th = arm(armid(uiid)).th + stepTh;
			end
			set(ui(uiid),'Value',arm(armid(uiid)).th);
		end
		arm=vectest9kinematics(arm,ind);
		plot1=vectest9plot2021(arm,plot1,sub22);
		drawnow
	end
end
